--
-- @author 寒歌
-- @description Main是应用的主模块，其中注册了应用运行中UI事件的回调、Activity生命周期的回调等
-- 你也可以在此编写启动事件代码，或控制应用运行逻辑、自定义应用UI等等。
-- @other 本模版已为你编写好基础事件，建议在阅读注释并理解相关参数意义后再进行扩展编写
--

-- ****默认导入包****
require "import"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
-- ****不需要请删除****


layout={
  LinearLayout;
  layout_height="fill";
  layout_width="fill";
  orientation="vertical";
  {
    EditText;
    id="edit";
    layout_height="40dp";
    layout_width="fill";
    hint="输入试试",
  };
  {
    GridView;
    id = "grid";
    layout_width = "fill";
    layout_height = "fill";
  };
   --同时也支持ListView。
  --[[ {
    ListView;
    id = "grid";
    layout_width = "fill";
    layout_height = "fill";
  };]]
};
activity.setContentView(loadlayout(layout))



--支持ListView GridView
--@Likefr

function setFilter(id)--核心断层
  id.setFilter(function(t, b, c)
    for i, v in ipairs(t) do
      if tostring(v.title):find(tostring(c), 0, true) then
        b[#b + 1] = v
      end
    end
  end)
end



item={
  LinearLayout,
  orientation="vertical",
  layout_width="fill",
  {
    TextView,
    id="title",
    layout_margin="15dp",
    layout_width="fill"
  },
}
--创建项目数组
data={}
--创建适配器
adp=LuaAdapter(activity,data,item)



ns={
  "Widget","Check view",
  "Adapter view",
  "Advanced Widget",
  "Layout",
  "Advanced Layout",
  "支持中文搜索",
  "模糊搜索"
}


--添加数据
for k,v in ipairs(ns) do
  adp.add({title=ns[k]})
end

--设置过滤后的数据
setFilter(adp)

--设置适配器
grid.Adapter=adp


edit.addTextChangedListener { --输入法监听
  afterTextChanged = function(str)
    adp.filter(tostring(str))
  end
}


--项目被单击
grid.onItemClick=function(l,v,p,i)
  print("点击了:" ..v.Tag.title.Text)
end